<?php

/**
 * Get data for sending an e-mail to the user
 *
 * @param int $userId - QUIQQER User Id
 * @return array
 *
 * @throws QUI\Exception
 */
QUI::$Ajax->registerFunction(
    'ajax_user_getMailData',
    function ($userId) {
        $User = QUI::getUsers()->get((int)$userId);

        return [
            'name'  => $User->getName(),
            'lang'  => QUI::getLocale()->get('quiqqer/quiqqer', 'language.'.$User->getLang()),
            'email' => $User->getAttribute('email')
        ];
    },
    ['userId'],
    'Permission::checkAdminUser'
);
